# coding: utf-8

"""
    FASva Data Management System API

    This is the API of the FASva management system.  # noqa: E501

    OpenAPI spec version: 0.1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from fasvadms_client.api_client import ApiClient


class SceneApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_scene_by_id(self, idscene, **kwargs):  # noqa: E501
        """Get a scene by its id  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_scene_by_id(idscene, async=True)
        >>> result = thread.get()

        :param async bool
        :param int idscene: The id of the scene. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_scene_by_id_with_http_info(idscene, **kwargs)  # noqa: E501
        else:
            (data) = self.get_scene_by_id_with_http_info(idscene, **kwargs)  # noqa: E501
            return data

    def get_scene_by_id_with_http_info(self, idscene, **kwargs):  # noqa: E501
        """Get a scene by its id  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_scene_by_id_with_http_info(idscene, async=True)
        >>> result = thread.get()

        :param async bool
        :param int idscene: The id of the scene. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['idscene']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_scene_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'idscene' is set
        if ('idscene' not in params or
                params['idscene'] is None):
            raise ValueError("Missing the required parameter `idscene` when calling `get_scene_by_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'idscene' in params:
            path_params['idscene'] = params['idscene']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/scene/{idscene}/', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_scene_by_time_and_drive(self, timestamp, iddrive, **kwargs):  # noqa: E501
        """Get a scene by its id  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_scene_by_time_and_drive(timestamp, iddrive, async=True)
        >>> result = thread.get()

        :param async bool
        :param int timestamp: The datetime of the scene. (required)
        :param int iddrive: The id of the drive. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_scene_by_time_and_drive_with_http_info(timestamp, iddrive, **kwargs)  # noqa: E501
        else:
            (data) = self.get_scene_by_time_and_drive_with_http_info(timestamp, iddrive, **kwargs)  # noqa: E501
            return data

    def get_scene_by_time_and_drive_with_http_info(self, timestamp, iddrive, **kwargs):  # noqa: E501
        """Get a scene by its id  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_scene_by_time_and_drive_with_http_info(timestamp, iddrive, async=True)
        >>> result = thread.get()

        :param async bool
        :param int timestamp: The datetime of the scene. (required)
        :param int iddrive: The id of the drive. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['timestamp', 'iddrive']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_scene_by_time_and_drive" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'timestamp' is set
        if ('timestamp' not in params or
                params['timestamp'] is None):
            raise ValueError("Missing the required parameter `timestamp` when calling `get_scene_by_time_and_drive`")  # noqa: E501
        # verify the required parameter 'iddrive' is set
        if ('iddrive' not in params or
                params['iddrive'] is None):
            raise ValueError("Missing the required parameter `iddrive` when calling `get_scene_by_time_and_drive`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'timestamp' in params:
            path_params['timestamp'] = params['timestamp']  # noqa: E501
        if 'iddrive' in params:
            path_params['iddrive'] = params['iddrive']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/scene/time/{timestamp}/drive/{iddrive}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_scene_by_time_interval(self, end_time, start_time, **kwargs):  # noqa: E501
        """Get all scenes of the drive with the &#x60;iddrive&#x60; within the interval defined by &#x60;start_time&#x60; and &#x60;end_time&#x60;  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_scene_by_time_interval(end_time, start_time, async=True)
        >>> result = thread.get()

        :param async bool
        :param int end_time: The time of the last scene. (required)
        :param int start_time: The time of the first scene. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_scene_by_time_interval_with_http_info(end_time, start_time, **kwargs)  # noqa: E501
        else:
            (data) = self.get_scene_by_time_interval_with_http_info(end_time, start_time, **kwargs)  # noqa: E501
            return data

    def get_scene_by_time_interval_with_http_info(self, end_time, start_time, **kwargs):  # noqa: E501
        """Get all scenes of the drive with the &#x60;iddrive&#x60; within the interval defined by &#x60;start_time&#x60; and &#x60;end_time&#x60;  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_scene_by_time_interval_with_http_info(end_time, start_time, async=True)
        >>> result = thread.get()

        :param async bool
        :param int end_time: The time of the last scene. (required)
        :param int start_time: The time of the first scene. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['end_time', 'start_time']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_scene_by_time_interval" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'end_time' is set
        if ('end_time' not in params or
                params['end_time'] is None):
            raise ValueError("Missing the required parameter `end_time` when calling `get_scene_by_time_interval`")  # noqa: E501
        # verify the required parameter 'start_time' is set
        if ('start_time' not in params or
                params['start_time'] is None):
            raise ValueError("Missing the required parameter `start_time` when calling `get_scene_by_time_interval`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'end_time' in params:
            path_params['end_time'] = params['end_time']  # noqa: E501
        if 'start_time' in params:
            path_params['start_time'] = params['start_time']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/scene/start/{start_time}/end/{end_time}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_scene_by_time_interval_and_drive(self, start_time, end_time, iddrive, **kwargs):  # noqa: E501
        """Get all scenes within the interval defined by &#x60;start_time&#x60; and &#x60;end_time&#x60;  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_scene_by_time_interval_and_drive(start_time, end_time, iddrive, async=True)
        >>> result = thread.get()

        :param async bool
        :param int start_time: The time of the first scene. (required)
        :param int end_time: The time of the last scene. (required)
        :param int iddrive: The id of the drive. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_scene_by_time_interval_and_drive_with_http_info(start_time, end_time, iddrive, **kwargs)  # noqa: E501
        else:
            (data) = self.get_scene_by_time_interval_and_drive_with_http_info(start_time, end_time, iddrive, **kwargs)  # noqa: E501
            return data

    def get_scene_by_time_interval_and_drive_with_http_info(self, start_time, end_time, iddrive, **kwargs):  # noqa: E501
        """Get all scenes within the interval defined by &#x60;start_time&#x60; and &#x60;end_time&#x60;  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_scene_by_time_interval_and_drive_with_http_info(start_time, end_time, iddrive, async=True)
        >>> result = thread.get()

        :param async bool
        :param int start_time: The time of the first scene. (required)
        :param int end_time: The time of the last scene. (required)
        :param int iddrive: The id of the drive. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['start_time', 'end_time', 'iddrive']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_scene_by_time_interval_and_drive" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'start_time' is set
        if ('start_time' not in params or
                params['start_time'] is None):
            raise ValueError("Missing the required parameter `start_time` when calling `get_scene_by_time_interval_and_drive`")  # noqa: E501
        # verify the required parameter 'end_time' is set
        if ('end_time' not in params or
                params['end_time'] is None):
            raise ValueError("Missing the required parameter `end_time` when calling `get_scene_by_time_interval_and_drive`")  # noqa: E501
        # verify the required parameter 'iddrive' is set
        if ('iddrive' not in params or
                params['iddrive'] is None):
            raise ValueError("Missing the required parameter `iddrive` when calling `get_scene_by_time_interval_and_drive`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'start_time' in params:
            path_params['start_time'] = params['start_time']  # noqa: E501
        if 'end_time' in params:
            path_params['end_time'] = params['end_time']  # noqa: E501
        if 'iddrive' in params:
            path_params['iddrive'] = params['iddrive']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/scene/start/{start_time}/end/{end_time}/drive/{iddrive}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_scene_info(self, idsignal, idscene, **kwargs):  # noqa: E501
        """Get the signal information (identified by &#x60;idsignal&#x60;) of the scene with the &#x60;idscene&#x60;  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_scene_info(idsignal, idscene, async=True)
        >>> result = thread.get()

        :param async bool
        :param str idsignal: The id of the signal. (required)
        :param int idscene: The id of the scene. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_scene_info_with_http_info(idsignal, idscene, **kwargs)  # noqa: E501
        else:
            (data) = self.get_scene_info_with_http_info(idsignal, idscene, **kwargs)  # noqa: E501
            return data

    def get_scene_info_with_http_info(self, idsignal, idscene, **kwargs):  # noqa: E501
        """Get the signal information (identified by &#x60;idsignal&#x60;) of the scene with the &#x60;idscene&#x60;  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_scene_info_with_http_info(idsignal, idscene, async=True)
        >>> result = thread.get()

        :param async bool
        :param str idsignal: The id of the signal. (required)
        :param int idscene: The id of the scene. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['idsignal', 'idscene']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_scene_info" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'idsignal' is set
        if ('idsignal' not in params or
                params['idsignal'] is None):
            raise ValueError("Missing the required parameter `idsignal` when calling `get_scene_info`")  # noqa: E501
        # verify the required parameter 'idscene' is set
        if ('idscene' not in params or
                params['idscene'] is None):
            raise ValueError("Missing the required parameter `idscene` when calling `get_scene_info`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'idsignal' in params:
            path_params['idsignal'] = params['idsignal']  # noqa: E501
        if 'idscene' in params:
            path_params['idscene'] = params['idscene']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/scene/{idscene}/signal/{idsignal}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_scene_list(self, **kwargs):  # noqa: E501
        """Get all scenes  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_scene_list(async=True)
        >>> result = thread.get()

        :param async bool
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_scene_list_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_scene_list_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_scene_list_with_http_info(self, **kwargs):  # noqa: E501
        """Get all scenes  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_scene_list_with_http_info(async=True)
        >>> result = thread.get()

        :param async bool
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_scene_list" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/scene/', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_scene_info(self, idsignal, idscene, payload, **kwargs):  # noqa: E501
        """Add new signal values for the scene identified by &#x60;idscene&#x60; for the signal identified by &#x60;idsignal&#x60;  # noqa: E501

        Can either be a single scene or a list of scenes.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.post_scene_info(idsignal, idscene, payload, async=True)
        >>> result = thread.get()

        :param async bool
        :param str idsignal: The id of the signal. (required)
        :param int idscene: The id of the scene. (required)
        :param SceneSignalValue payload: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.post_scene_info_with_http_info(idsignal, idscene, payload, **kwargs)  # noqa: E501
        else:
            (data) = self.post_scene_info_with_http_info(idsignal, idscene, payload, **kwargs)  # noqa: E501
            return data

    def post_scene_info_with_http_info(self, idsignal, idscene, payload, **kwargs):  # noqa: E501
        """Add new signal values for the scene identified by &#x60;idscene&#x60; for the signal identified by &#x60;idsignal&#x60;  # noqa: E501

        Can either be a single scene or a list of scenes.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.post_scene_info_with_http_info(idsignal, idscene, payload, async=True)
        >>> result = thread.get()

        :param async bool
        :param str idsignal: The id of the signal. (required)
        :param int idscene: The id of the scene. (required)
        :param SceneSignalValue payload: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['idsignal', 'idscene', 'payload']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_scene_info" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'idsignal' is set
        if ('idsignal' not in params or
                params['idsignal'] is None):
            raise ValueError("Missing the required parameter `idsignal` when calling `post_scene_info`")  # noqa: E501
        # verify the required parameter 'idscene' is set
        if ('idscene' not in params or
                params['idscene'] is None):
            raise ValueError("Missing the required parameter `idscene` when calling `post_scene_info`")  # noqa: E501
        # verify the required parameter 'payload' is set
        if ('payload' not in params or
                params['payload'] is None):
            raise ValueError("Missing the required parameter `payload` when calling `post_scene_info`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'idsignal' in params:
            path_params['idsignal'] = params['idsignal']  # noqa: E501
        if 'idscene' in params:
            path_params['idscene'] = params['idscene']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'payload' in params:
            body_params = params['payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/scene/{idscene}/signal/{idsignal}', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_scene_list(self, payload, **kwargs):  # noqa: E501
        """Add new scenes to the database  # noqa: E501

        Can either be a single scene or a list of scenes.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.post_scene_list(payload, async=True)
        >>> result = thread.get()

        :param async bool
        :param Scene payload: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.post_scene_list_with_http_info(payload, **kwargs)  # noqa: E501
        else:
            (data) = self.post_scene_list_with_http_info(payload, **kwargs)  # noqa: E501
            return data

    def post_scene_list_with_http_info(self, payload, **kwargs):  # noqa: E501
        """Add new scenes to the database  # noqa: E501

        Can either be a single scene or a list of scenes.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.post_scene_list_with_http_info(payload, async=True)
        >>> result = thread.get()

        :param async bool
        :param Scene payload: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['payload']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_scene_list" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'payload' is set
        if ('payload' not in params or
                params['payload'] is None):
            raise ValueError("Missing the required parameter `payload` when calling `post_scene_list`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'payload' in params:
            body_params = params['payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/scene/', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def put_scene_by_id(self, idscene, payload, **kwargs):  # noqa: E501
        """Updates the scene with the &#x60;idscene&#x60;  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.put_scene_by_id(idscene, payload, async=True)
        >>> result = thread.get()

        :param async bool
        :param int idscene: The id of the scene. (required)
        :param Scene payload: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.put_scene_by_id_with_http_info(idscene, payload, **kwargs)  # noqa: E501
        else:
            (data) = self.put_scene_by_id_with_http_info(idscene, payload, **kwargs)  # noqa: E501
            return data

    def put_scene_by_id_with_http_info(self, idscene, payload, **kwargs):  # noqa: E501
        """Updates the scene with the &#x60;idscene&#x60;  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.put_scene_by_id_with_http_info(idscene, payload, async=True)
        >>> result = thread.get()

        :param async bool
        :param int idscene: The id of the scene. (required)
        :param Scene payload: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['idscene', 'payload']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method put_scene_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'idscene' is set
        if ('idscene' not in params or
                params['idscene'] is None):
            raise ValueError("Missing the required parameter `idscene` when calling `put_scene_by_id`")  # noqa: E501
        # verify the required parameter 'payload' is set
        if ('payload' not in params or
                params['payload'] is None):
            raise ValueError("Missing the required parameter `payload` when calling `put_scene_by_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'idscene' in params:
            path_params['idscene'] = params['idscene']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'payload' in params:
            body_params = params['payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/scene/{idscene}/', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
